searchNodes=[{"doc":"A library for generating JSON-API.org spec compliant JSON.JaSerializer has three main public components:JaSerializer.Serializer - A Behaviour defining how a particular object is serialized. Provides default empty callbacks and ability to override.JaSerializer.DSL - A macro based DSL that sits on top of the Behaviour for quick, clean, and easy definition of serializers.JaSerializer.PhoenixView - Provides render functions for a view to take advantage of the serialization interface.When used the JaSerializer module includes the Behaviour and DSL by default. The DSL can be opted out of by passing dsl: false, eg:defmodule MyApp.PostSerializer do use JaSerializer, dsl: false # ... endIf using JaSerializer with Phoenix, your normal entry point is JaSerializer.PhoenixView, eg:defmodule MyApp.PostView do use MyApp.Web, :view use JaSerializer.PhoenixView # ... end","ref":"JaSerializer.html","title":"JaSerializer","type":"module"},{"doc":"Main serialization method.Accepts a module implementing the JaSerializer.Serializer behaviour, data, the conn and opts and returns a map ready for json encoding.","ref":"JaSerializer.html#format/4","title":"JaSerializer.format/4","type":"function"},{"doc":"Builds JSON-API spec pagination links.Pass in a map with the necessary data:JaSerializer.Builder.PaginationLinks.build(%{ number: 1, size: 20, total: 5, base_url: &quot;https://example.com&quot; }, Plug.Conn%{} )Would produce a list of links such as:[ self: &quot;https://example.com/posts?page[number]=2&amp;page[size]=10&quot;, next: &quot;https://example.com/posts?page[number]=3&amp;page[size]=10&quot;, first: &quot;https://example.com/posts?page[number]=1&amp;page[size]=10&quot;, last: &quot;https://example.com/posts?page[number]=20&amp;page[size]=10&quot; ]The param names can be customized on your application's config:config :ja_serializer, page_key: &quot;page&quot;, page_base_url: &quot;https://example.com/posts&quot; page_number_key: &quot;offset&quot;, page_size_key: &quot;limit&quot;, page_number_origin: 0,The defaults are:page_key : &quot;page&quot;page_base_url: nilpage_number_key: &quot;number&quot;page_size_key : &quot;size&quot;page_number_origin: 1Please note that if the value for page_number_origin is changed JaSerializer will have to be recompiled:$ mix deps.clean ja_serializer $ mix deps.get ja_serializer","ref":"JaSerializer.Builder.PaginationLinks.html","title":"JaSerializer.Builder.PaginationLinks","type":"module"},{"doc":"","ref":"JaSerializer.Builder.PaginationLinks.html#build/2","title":"JaSerializer.Builder.PaginationLinks.build/2","type":"function"},{"doc":"Builds JSON-API spec pagination links for %Scrivener.Page{}.","ref":"JaSerializer.Builder.ScrivenerLinks.html","title":"JaSerializer.Builder.ScrivenerLinks","type":"module"},{"doc":"","ref":"JaSerializer.Builder.ScrivenerLinks.html#build/1","title":"JaSerializer.Builder.ScrivenerLinks.build/1","type":"function"},{"doc":"Utilities to work with building serialized data","ref":"JaSerializer.Builder.Utils.html","title":"JaSerializer.Builder.Utils","type":"module"},{"doc":"","ref":"JaSerializer.Builder.Utils.html#normalize_includes/1","title":"JaSerializer.Builder.Utils.normalize_includes/1","type":"function"},{"doc":"","ref":"JaSerializer.Builder.Utils.html#safe_atom_list/1","title":"JaSerializer.Builder.Utils.safe_atom_list/1","type":"function"},{"doc":"This plug provides content type negotiation by validating the content-type and accept headers.The proper jsonapi.org content type is: application/vnd.api+json.As per the spec this plug does three things.Returns 415 unless the content-type header is correct.Returns 406 unless the accept header is correct.Registers a before send hook to set the content-type if not already set.UsageJust include in your plug stack:plug JaSerializer.ContentTypeNegotiation","ref":"JaSerializer.ContentTypeNegotiation.html","title":"JaSerializer.ContentTypeNegotiation","type":"module"},{"doc":"Callback implementation for Plug.call/2.","ref":"JaSerializer.ContentTypeNegotiation.html#call/2","title":"JaSerializer.ContentTypeNegotiation.call/2","type":"function"},{"doc":"Callback implementation for Plug.init/1.","ref":"JaSerializer.ContentTypeNegotiation.html#init/1","title":"JaSerializer.ContentTypeNegotiation.init/1","type":"function"},{"doc":"","ref":"JaSerializer.ContentTypeNegotiation.html#set_content_type/2","title":"JaSerializer.ContentTypeNegotiation.set_content_type/2","type":"function"},{"doc":"","ref":"JaSerializer.ContentTypeNegotiation.html#verify_accepts/2","title":"JaSerializer.ContentTypeNegotiation.verify_accepts/2","type":"function"},{"doc":"","ref":"JaSerializer.ContentTypeNegotiation.html#verify_content_type/2","title":"JaSerializer.ContentTypeNegotiation.verify_content_type/2","type":"function"},{"doc":"A DSL for defining JSON-API.org spec compliant payloads.Built on top of the JaSerializer.Serializer behaviour.The following macros are available:location/1 - Define the url of a single serialized object.attributes/1 - Define the attributes to be returned.has_many/2 - Define a has_many relationship.has_one/2 - Define a has_one or belongs_to relationship.This module should always be used in conjunction with JaSerializer.Serializer, see JaSerializer for the best way to do so.DSL Usage Exampledefmodule PostSerializer do use JaSerializer, dsl: true location &quot;/posts/:id&quot; attributes [:title, :body, :excerpt, :tags] has_many :comments, links: [related: &quot;/posts/:id/comments&quot;] has_one :author, serializer: PersonSerializer, include: true def excerpt(post, _conn) do [first | _ ] = String.split(post.body, &quot;.&quot;) first end end post = %Post{ id: 1, title: &quot;jsonapi.org + Elixir = Awesome APIs&quot;, body: &quot;so. much. awesome.&quot;, author: %Person{name: &quot;Alan&quot;} } post |&gt; PostSerializer.format |&gt; Poison.encode!When useing JaSerializer.DSL the default implementations of the links/2, attributes/2, and relationships/2 callbacks will be defined on your module.Overriding these callbacks can be a great way to customize your serializer beyond what the DSL provides. See JaSerializer.Serializer for examples.","ref":"JaSerializer.DSL.html","title":"JaSerializer.DSL","type":"module"},{"doc":"Defines a list of attributes as atoms to be included in the payload.An overridable function for each attribute is generated with the same name as the attribute. The function's default behavior is to retrieve a field with the same name from the struct.For example, if you have attributes [:body] a function body/2 is defined on the serializer with a default behavior of Map.get(struct, :body).defmodule PostSerializer do use JaSerializer, dsl: true attributes [:title, :body, :html] def html(post, _conn) do Earmark.to_html(post.body) end endConditional attribute inclusionJaSerializer supports the fields option as per the JSONAPI spec. This option allows clients to request only the fields they want. For example if you only wanted the html and the title for the post:field_param = %{&quot;post&quot; =&gt; &quot;title,html&quot;, &quot;comment&quot; =&gt; &quot;html&quot;} # Direct Serialization PostSerializer.format(post, conn, fields: field_param) # via PhoenixView integrations from controller render(conn, :show, data: post, opts: [fields: field_param])Further customizationFurther customization of the attributes returned can be handled by overriding the attributes/2 callback. This can be done in conjunction with the DSL using super, or without the DSL just returning a map.","ref":"JaSerializer.DSL.html#attributes/1","title":"JaSerializer.DSL.attributes/1","type":"macro"},{"doc":"Add a has_many relationship to be serialized.JSONAPI.org supports three types or relationships:As links - Great for clients lazy loading relationships with lots of data.As &quot;Resource Indentifiers&quot; - A type/id pair, useful to relate to data the client already has.As Included Resources - The full resource is serialized in the same request (also includes Resource Identifiers).Links can be combined with either resource identifiers or fully included resources.See http://jsonapi.org/format/#document-resource-object-relationships for more details on the spec.Link based relationshipsSpecify a URI or path which responds with the related resource. For example:defmodule MyApp.PostView do use JaSerializer has_many :comments, link: :comments_link has_one :author, link: &quot;/api/posts/:id/author&quot; def comments_link(post, conn) do MyApp.Router.Helpers.post_comment_url(conn, :index, post.id) end endLinks can be defined with an atom or string.String may be either a relative or absolute path. Path segments beginning with a colon are called as functions on the serializer with the struct and conn passed in. In the above example id/2 would be called which is defined as a default callback.When an atom is passed in, it is called as a function on the serializer with the struct and conn passed in. The function should return a full path/url.Both related and self links are supported, the default link creates a related link:defmodule PostSerializer do use JaSerializer has_many :comments, links: [ related: &quot;/posts/:id/comments&quot; self: &quot;/posts/:id/relationships/comments&quot; ] endResource Identifiers (without including)Return id and type for each related object (&quot;Resource Identifier&quot;). For example:defmodule MyApp.PostView do use JaSerializer has_many :comments, serializer: MyApp.CommentView, include: false has_many :tags, type: &quot;tags&quot; has_one :author, type: &quot;user&quot;, field: :created_by_id # ... endWhen you use the has_many and has_one macros an overridable &quot;data source&quot; function is defined on your module. The data source function has the same name as the relationship name and accepts the struct and conn. The data source function should return the related struct(s) or id(s). In the example above the following functions are defined for you:def comments(post, _conn), do: Map.get(post, :comments) def tags(post, _conn), do: Map.get(post, :tags) def author(post, _conn), do: Map.get(post, :created_by_id)These data source functions are expected to return either related objects or ids, by default they just access the field with the same name as the relationship. The field option can be used to grab the id or struct from a different field in the serialized object. The author is an example of customizing this, and is frequently used when returning resource identifiers for has_one relationships when you have the foreign key in the serialized struct.In the comments example when a serializer plus include: false options are used the id/2 and type/2 functions are called on the defined serializer.In the tags example where just the type option is used the id field is automatically used on each map/struct returned by the data source.It is important to note that when accessing the relationship fields it is expected that the relationship is preloaded. For this reason you may want to consider using links for has_many relationships where possible.Including related dataReturns a &quot;Resource Identifier&quot; (see above) as well as the fully serialized object in the top level included key. Example:defmodule MyApp.PostView do use JaSerializer has_many :comments, serializer: MyApp.CommentView, include: true, identifiers: :when_included has_many :tags, serializer: MyApp.TagView, include: true, identifiers: :always has_many :author, serializer: MyApp.AuthorView, include: true, field: :created_by # ... endJust like when working with only Resource Identifiers this will define a 'data source' function for each relationship with an arity of two. They will be overridable and are expected to return maps/structs.Conditional InclusionJaSerializer supports the include option as per the JSONAPI spec. This option allows clients to include only the relationships they want. JaSerializer handles the serialization of this for you, however you will have to handle intelligent preloading of relationships yourself.When a relationship is not loaded via includes the identifiers option will be used to determine if Resource Identifiers should be serialized or not. The identifiers options accepts the atoms :when_included and :always.When specifying the include param, only the relationship requested will be included. For example, to only include the author and comments:include_param = &quot;author,comments&quot; # Direct Serialization PostSerializer.format(post, conn, include: include_param) # via PhoenixView integrations from controller render(conn, :show, data: post, opts: [include: include_param])Further CustomizationFor further customization override the relationships/2 callback directly.","ref":"JaSerializer.DSL.html#has_many/2","title":"JaSerializer.DSL.has_many/2","type":"macro"},{"doc":"See documentation for &lt;a href='#has_many/2'&gt;has_many/2&lt;/a&gt;.API is the exact same with one exception:In the case of a belongs to relationship, JaSerializer will attempt to work out the resource identifier when the relationship is not included/preloaded. This reduces the amount of boiler plate code needed when relationship inclusion is specified by the client (as opposed to using include: true in the serializer).By default, JaSerializer appends _id to the resource name, but this can be overridden with the foreign_key option.In the following example, the user and author identifiers will be serialized even if those relationships are not preloaded.defmodule MyApp.PostView do use JaSerializer has_one :user, identifiers: :always, serializer: MyApp.UserView has_one :author, identifiers: :always, foreign_key: :user_id, serializer: MyApp.UserView end","ref":"JaSerializer.DSL.html#has_one/2","title":"JaSerializer.DSL.has_one/2","type":"macro"},{"doc":"Defines the canonical path for retrieving this resource.String ExamplesString may be either a relative or absolute path. Path segments beginning with a colon are called as functions on the serializer with the struct and conn passed in.defmodule PostSerializer do use JaSerializer location &quot;/posts/:id&quot; end defmodule CommentSerializer do use JaSerializer location &quot;http://api.example.com/posts/:post_id/comments/:id&quot; def post_id(comment, _conn), do: comment.post_id endAtom ExampleWhen an atom is passed in, it is called as a function on the serializer with the struct and conn passed in. The function should return a full path/url.defmodule PostSerializer do use JaSerializer import MyPhoenixApp.Router.Helpers location :post_url def post_url(post, conn) do post_path(conn, :show, post.id) end end","ref":"JaSerializer.DSL.html#location/1","title":"JaSerializer.DSL.location/1","type":"macro"},{"doc":"This plug &quot;deserializes&quot; params to underscores.For example these params:%{ &quot;data&quot; =&gt; %{ &quot;attributes&quot; =&gt; %{ &quot;foo-bar&quot; =&gt; true } } }are transformed to:%{ &quot;data&quot; =&gt; %{ &quot;attributes&quot; =&gt; %{ &quot;foo_bar&quot; =&gt; true } } }UsageJust include in your plug stack after a json parser:plug Plug.Parsers, parsers: [:json], json_decoder: Poison plug JaSerializer.Deserializer","ref":"JaSerializer.Deserializer.html","title":"JaSerializer.Deserializer","type":"module"},{"doc":"Callback implementation for Plug.call/2.","ref":"JaSerializer.Deserializer.html#call/2","title":"JaSerializer.Deserializer.call/2","type":"function"},{"doc":"Callback implementation for Plug.init/1.","ref":"JaSerializer.Deserializer.html#init/1","title":"JaSerializer.Deserializer.init/1","type":"function"},{"doc":"The EctoErrorSerializer is used to transform Ecto changeset errors to JSON API standard error objects.If a changeset is past in without optional error members then the object returned will only contain: source, title, and detail.%{&quot;errors&quot; =&gt; [ %{ source: %{pointer: &quot;/data/attributes/monies&quot;}, title: &quot;must be more than 10&quot;, detail: &quot;Monies must be more than 10&quot; } ] } Additional error members can be set by passing in an options list. These include: id, status, code, meta, and links.For more information on the JSON API standard for handling error objects check_origin: jsonapi.org","ref":"JaSerializer.EctoErrorSerializer.html","title":"JaSerializer.EctoErrorSerializer","type":"module"},{"doc":"","ref":"JaSerializer.EctoErrorSerializer.html#format/1","title":"JaSerializer.EctoErrorSerializer.format/1","type":"function"},{"doc":"","ref":"JaSerializer.EctoErrorSerializer.html#format/2","title":"JaSerializer.EctoErrorSerializer.format/2","type":"function"},{"doc":"","ref":"JaSerializer.EctoErrorSerializer.html#format/3","title":"JaSerializer.EctoErrorSerializer.format/3","type":"function"},{"doc":"A super basic wrapper for formatting jsonapi errors.Takes a map (or list of maps) with the following keys::id :links :about :status :code :title :detail :source :metaSee http://jsonapi.org/format/#error-objects for more on errors.","ref":"JaSerializer.ErrorSerializer.html","title":"JaSerializer.ErrorSerializer","type":"module"},{"doc":"","ref":"JaSerializer.ErrorSerializer.html#format/1","title":"JaSerializer.ErrorSerializer.format/1","type":"function"},{"doc":"","ref":"JaSerializer.ErrorSerializer.html#format/2","title":"JaSerializer.ErrorSerializer.format/2","type":"function"},{"doc":"","ref":"JaSerializer.ErrorSerializer.html#format/3","title":"JaSerializer.ErrorSerializer.format/3","type":"function"},{"doc":"","ref":"JaSerializer.Formatter.html","title":"JaSerializer.Formatter","type":"protocol"},{"doc":"","ref":"JaSerializer.Formatter.html#format/1","title":"JaSerializer.Formatter.format/1","type":"function"},{"doc":"","ref":"JaSerializer.Formatter.html#t:t/0","title":"JaSerializer.Formatter.t/0","type":"type"},{"doc":"","ref":"JaSerializer.ParamParser.html","title":"JaSerializer.ParamParser","type":"protocol"},{"doc":"","ref":"JaSerializer.ParamParser.html#parse/1","title":"JaSerializer.ParamParser.parse/1","type":"function"},{"doc":"","ref":"JaSerializer.ParamParser.html#t:t/0","title":"JaSerializer.ParamParser.t/0","type":"type"},{"doc":"Functions to help when working with json api params.","ref":"JaSerializer.Params.html","title":"JaSerializer.Params","type":"module"},{"doc":"Takes the entire params passed in, and merges relationships and attributes.Note, this expects to receive the json api &quot;data&quot; param.Example functionality:JaSerializer.Params.to_attributes(%{ &quot;type&quot; =&gt; &quot;person&quot;, &quot;attributes&quot; =&gt; %{&quot;first&quot; =&gt; &quot;Jane&quot;, &quot;last&quot; =&gt; &quot;Doe&quot;, &quot;type&quot; =&gt; &quot;anon&quot;}, &quot;relationships&quot; =&gt; %{&quot;user&quot; =&gt; %{&quot;data&quot; =&gt; %{&quot;id&quot; =&gt; 1}}} }) %{ &quot;first&quot; =&gt; &quot;Jane&quot;, &quot;last&quot; =&gt; &quot;Doe&quot;, &quot;type&quot; =&gt; &quot;anon&quot;, &quot;user_id&quot; =&gt; 1 }Example usage:def create(conn, %{&quot;data&quot; =&gt; data}) do %Comment{} |&gt; Comment.changeset(create_params(data)) |&gt; Repo.insert |&gt; case do {:ok, my_model} -&gt; # etc {:error, changeset} -&gt; etc # etc end end defp create_params(data) do data |&gt; JaSerializer.Params.to_attributes |&gt; Map.take([&quot;name&quot;, &quot;body&quot;, &quot;post_id&quot;]) end","ref":"JaSerializer.Params.html#to_attributes/1","title":"JaSerializer.Params.to_attributes/1","type":"function"},{"doc":"Use in your Phoenix.View to render jsonapi.org spec json.See JaSerializer.Serializer for documentation on defining your serializer.Usage exampledefmodule PhoenixExample.ArticleView do use PhoenixExample.Web, :view use JaSerializer.PhoenixView # Or use in web/web.ex attributes [:title] has_many :comments, serializer: PhoenixExample.CommentsView, include: false, identifiers: :when_included end defmodule PhoenixExample.ArticlesController do use PhoenixExample.Web, :controller def index(conn, _params) do render conn, &quot;index.json-api&quot;, data: Repo.all(Article) end def show(conn, %{&quot;id&quot; =&gt; id}) do article = Repo.get(Article, id) |&gt; Repo.preload([:comments]) render conn, &quot;show.json-api&quot;, data: article, opts: [include: &quot;comments&quot;] end def create(conn, %{&quot;data&quot; =&gt; %{&quot;attributes&quot; =&gt; attrs}}) do changeset = Article.changeset(%Article{}, attrs) case Repo.insert(changeset) do {:ok, article} -&gt; conn |&gt; put_status(201) |&gt; render(&quot;show.json-api&quot;, data: article) {:error, changeset} -&gt; conn |&gt; put_status(422) |&gt; render(:errors, data: changeset) end end end","ref":"JaSerializer.PhoenixView.html","title":"JaSerializer.PhoenixView","type":"module"},{"doc":"Extracts the data and opts from the keyword list passed to render and returns result of formatting.","ref":"JaSerializer.PhoenixView.html#render/2","title":"JaSerializer.PhoenixView.render/2","type":"function"},{"doc":"Extracts the errors and opts from the data passed to render and returns result of formatting.data is expected to be either an invalid Ecto.Changeset or preformatted errors as described in JaSerializer.ErrorSerializer.","ref":"JaSerializer.PhoenixView.html#render_errors/1","title":"JaSerializer.PhoenixView.render_errors/1","type":"function"},{"doc":"Struct to represent a HasMany relationship.The fields are:serializer - A Serializer (often a PhoenixView) implementing the JaSerializer.Serializer behaviour.include - Should this relationship be included (sideloaded) by default. Overridden by include opt to JaSerializer.format/4data - A list of structs representing the data.identifiers - Should &quot;resource identifiers be included, options are :when_included and :always. Defaults to :when_includedlinks - A keyword list of links, self and related are most common.name - Name of the relationship, automatically set.Used when defining relationships without the DSL using the JaSerializer.relationships/2 callback. For example:def relationships(article, _conn) do %{ comments: %HasMany{ serializer: MyApp.CommentView, include: true, data: article.comments, } } endSee JaSerializer.DSL.has_many/2 for information on defining different types of relationships.","ref":"JaSerializer.Relationship.HasMany.html","title":"JaSerializer.Relationship.HasMany","type":"module"},{"doc":"Struct representing a HasOne (or belongs to) relationship.The fields are:serializer - A Serializer (often a PhoenixView) implementing the JaSerializer.Serializer behaviour.include - Should this relationship be included (sideloaded) by default. Overridden by include opt to JaSerializer.format/4data - A struct representing the data for serialization.identifiers - Should &quot;resource identifiers be included, options are :when_included and :always. Defaults to :alwayslinks - A keyword list of links, self and related are most common.name - Name of the relationship, automatically set.Used when defining relationships without the DSL using the JaSerializer.relationships/2 callback. For example:def relationships(article, _conn) do %{ comments: %HasOne{ serializer: MyApp.CommentView, include: true, data: article.comments, } } endSee JaSerializer.DSL.has_many/2 for information on defining different types of relationships.","ref":"JaSerializer.Relationship.HasOne.html","title":"JaSerializer.Relationship.HasOne","type":"module"},{"doc":"A Behaviour for defining JSON-API.org spec complaint payloads.The following callbacks are available:id/2 - Return ID of struct to be serialized.type/2 - Return string type of struct to be serialized.attributes/2 - A map of attributes to be serialized.relationships/2- A map of HasMany and HasOne data structures.links/2 - A keyword list of any links pertaining to this struct.meta/2 - A map of any additional meta information to be serialized.preload/3 - A special callback that can be used to preload related data.A Serializer (or view) is typically one of the few places in an API where content and context are both present. To accommodate this each callback gets the data being serialized (typically a struct, often called a model) and the Plug.Conn as arguments. Context data such as the current user, role, etc should typically be made available on the conn.When useing this module all callbacks get a default, overridable implementation. The JaSerializer.DSL module also provides some default implementations of these callbacks built up from the DSL. When using the DSL overriding the Behaviour functions can be a great way to customize conditional logic.While not typically used directly, the interface for returning formatted data is also defined. The results still need to be encoded into JSON as appropriate.defmodule FooSerializer do use JaSerializer end # Format one foo FooSerializer.format(one_foo, conn, meta) # Format many foos FooSerializer.format(many_foos, conn, meta)","ref":"JaSerializer.Serializer.html","title":"JaSerializer.Serializer","type":"behaviour"},{"doc":"Returns a map of attributes to be serialized.The default implementation returns all the data's fields except id, type, and __struct__.A typical non-DSL implementation looks like:defmodule UserSerializer do def attributes(user, conn) do Map.take(user, [:email, :name]) end end UserSerializer.attributes(user, conn) # %{email: &quot;...&quot;, name: &quot;...&quot;}If using the JaSerializer.DSL the default implementation is based on the JaSerializer.DSL.attributes/1 macro. Eg:defmodule UserSerializer do attributes [:email, :name, :is_admin] end UserSerializer.attributes(user, conn) # %{email: &quot;...&quot;, name: &quot;...&quot;, is_admin: &quot;...&quot;}Overriding this callback can be a good way to customize attribute behaviour based on the context (conn) with super.defmodule UserSerializer do attributes [:email, :name, :is_admin] def attributes(user, %{assigns: %{current_user: %{is_admin: true}}}) do super(user, conn) end def attributes(user, conn) do super(user, conn) |&gt; Map.take([:email, :name]) end end UserSerializer.attributes(user, conn) # %{email: &quot;...&quot;, name: &quot;...&quot;}","ref":"JaSerializer.Serializer.html#c:attributes/2","title":"JaSerializer.Serializer.attributes/2","type":"callback"},{"doc":"The id to be used in the resource object.http://jsonapi.org/format/#document-resource-objectsDefault implementation attempts to get the :id field from the struct.To override simply define the id function:def id(struct, _conn), do: struct.slug","ref":"JaSerializer.Serializer.html#c:id/2","title":"JaSerializer.Serializer.id/2","type":"callback"},{"doc":"return links about this resource","ref":"JaSerializer.Serializer.html#c:links/2","title":"JaSerializer.Serializer.links/2","type":"callback"},{"doc":"Adds meta data to the individual resource being serialized.NOTE: To add meta data to the top level object pass the meta: option into YourSerializer.format/3.A nil return value results in no meta key being added to the serializer. A map return value will be formatted with JaSerializer.Formatter.format/1.The default implementation returns nil.","ref":"JaSerializer.Serializer.html#c:meta/2","title":"JaSerializer.Serializer.meta/2","type":"callback"},{"doc":"A special callback that can be used to preload related data.Unlike the other callbacks, this callback is ONLY executed on the top level data being serialized. Also unlike any other callback when serializing a list of data (eg: from an index action) it receives the entire list, not each individual post. When serializing a single record (eg, show, create, update) a single record is received.The primary use case of the callback is to preload all the relationships you need. For example:@default_includes [:category, comments: :author] def preload(record_or_records, _conn, []) do MyApp.Repo.preload(record_or_records, @default_includes) end def preload(record_or_records, _conn, include_opts) do MyApp.Repo.preload(record_or_records, include_opts) end","ref":"JaSerializer.Serializer.html#c:preload/3","title":"JaSerializer.Serializer.preload/3","type":"callback"},{"doc":"A callback that should return a map of relationship structs.Example:def relationships(article, _conn) do %{ comments: %HasMany{ serializer: MyApp.CommentView, include: true, data: article.comments, }, author: %HasOne{ serializer: MyApp.AuthorView, include: true, data: article.author, } } endSee JaSerializer.Relationship.HasMany for details on fields.When using the DSL this is defined for you based on the has_many and has_one macros.","ref":"JaSerializer.Serializer.html#c:relationships/2","title":"JaSerializer.Serializer.relationships/2","type":"callback"},{"doc":"The type to be used in the resource object.http://jsonapi.org/format/#document-resource-objectsDefault implementation attempts to infer the type from the serializer module's name. For example:MyApp.UserView becomes &quot;user&quot; MyApp.V1.Serializers.Post becomes &quot;post&quot; MyApp.V1.CommentsSerializer becomes &quot;comments&quot;To override simply define the type function:def type(_post,_conn), do: &quot;category&quot;Ordef type, do: &quot;category&quot;","ref":"JaSerializer.Serializer.html#c:type/0","title":"JaSerializer.Serializer.type/0","type":"callback"},{"doc":"","ref":"JaSerializer.Serializer.html#c:type/2","title":"JaSerializer.Serializer.type/2","type":"callback"},{"doc":"","ref":"JaSerializer.Serializer.html#t:data/0","title":"JaSerializer.Serializer.data/0","type":"type"},{"doc":"","ref":"JaSerializer.Serializer.html#t:id/0","title":"JaSerializer.Serializer.id/0","type":"type"},{"doc":"","ref":"JaSerializer.AssociationNotLoadedError.html","title":"JaSerializer.AssociationNotLoadedError","type":"exception"},{"doc":"","ref":"JaSerializer.ReservedKeywordError.html","title":"JaSerializer.ReservedKeywordError","type":"exception"}]